import { Emitter } from "strict-event-emitter";
import {
  matchRequestUrl
} from '../utils/matching/matchRequestUrl.mjs';
import { getCallFrame } from '../utils/internal/getCallFrame.mjs';
const kEmitter = Symbol("kEmitter");
const kDispatchEvent = Symbol("kDispatchEvent");
const kSender = Symbol("kSender");
class WebSocketHandler {
  constructor(url) {
    this.url = url;
    this[kEmitter] = new Emitter();
    this.callFrame = getCallFrame(new Error());
  }
  callFrame;
  [kEmitter];
  parse(args) {
    const connection = args.event.data;
    const match = matchRequestUrl(connection.client.url, this.url);
    return {
      match
    };
  }
  predicate(args) {
    return args.parsedResult.match.matches;
  }
  async [kDispatchEvent](event) {
    const parsedResult = this.parse({ event });
    const connection = event.data;
    const resolvedConnection = {
      client: connection.client,
      server: connection.server,
      params: parsedResult.match.params || {}
    };
    this[kEmitter].emit("connection", resolvedConnection);
  }
}
export {
  WebSocketHandler,
  kDispatchEvent,
  kEmitter,
  kSender
};
//# sourceMappingURL=WebSocketHandler.mjs.map