"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var handleWebSocketEvent_exports = {};
__export(handleWebSocketEvent_exports, {
  handleWebSocketEvent: () => handleWebSocketEvent
});
module.exports = __toCommonJS(handleWebSocketEvent_exports);
var import_WebSocketHandler = require("../handlers/WebSocketHandler.js");
var import_webSocketInterceptor = require("./webSocketInterceptor.js");
function handleWebSocketEvent(options) {
  import_webSocketInterceptor.webSocketInterceptor.on("connection", (connection) => {
    const handlers = options.getHandlers();
    const connectionEvent = new MessageEvent("connection", {
      data: connection
    });
    const matchingHandlers = handlers.filter(
      (handler) => {
        if (handler instanceof import_WebSocketHandler.WebSocketHandler) {
          return handler.predicate({
            event: connectionEvent,
            parsedResult: handler.parse({
              event: connectionEvent
            })
          });
        }
        return false;
      }
    );
    if (matchingHandlers.length > 0) {
      options?.onMockedConnection(connection);
      for (const handler of matchingHandlers) {
        handler[import_WebSocketHandler.kDispatchEvent](connectionEvent);
      }
    } else {
      options?.onPassthroughConnection(connection);
      connection.server.connect();
    }
  });
}
//# sourceMappingURL=handleWebSocketEvent.js.map